//
//  FBullCowGame.hpp
//  BullCowGame
//
//  Created by Brett Mayes on 20/12/2019.
//  Copyright © 2019 Brett Mayes. All rights reserved.
//
#pragma once
#ifndef FBullCowGame_hpp
#define FBullCowGame_hpp

#include <stdio.h>
#include <string>

//Make code consistent with Unreal coding practice
using FString = std::string;
using int32 = int;

struct FBullCowCount
{
    int32 Bulls = 0;
    int32 Cows = 0;
};

struct WordList
{
    FString word[10];
};

enum class EWordStatus
{
    Invalid_Status,
    OK,
    Not_Isogram,
    Wrong_Length,
    Not_Lowercase,
};

enum class EWordLength
{
    OK,
    Not_Integer,
    Out_Of_Range,
};

class FBullCowGame
{
public:
    FBullCowGame();
    
    int32 GetMaxTries() const;
    int32 GetCurrentTry() const;
    int32 GetHiddenWordLength() const;
    void GetWord(FString);
    bool IsGameWon() const;
    void SetDifficulty(FString);

    void Reset();
    EWordStatus CheckGuessValidity(FString);
    
    FBullCowCount SubmitValidGuess(FString);

private:
    int32 MyCurrentTry;
    FString MyHiddenWord;
    bool bIsWon;
    int32 Difficulty;
    
    bool IsIsogram(FString) const;
    bool IsLowerCase(FString) const;

    

};

#endif /* FBullCowGame_hpp */
